/* ploticus data display engine.  Software, documentation, and examples.  
 * Copyright 1998-2001 Stephen C. Grubb  (scg@jax.org).
 * Covered by GPL; see the file ./Copyright for details. */

/* PROC BEVELRECT - bevelled rectange, e.g. for button */

#include "pl.h"


PLP_bevelrect()
{
int i;
char attr[40], val[256];
char *line, *lineval;
int nt, lvp;
int first;

int stat;
int align;
double adjx, adjy;

double xlo, ylo, xhi, yhi;
char color[40];
double bevelsize;
char lowbevelcolor[40], hibevelcolor[40], shadowcolor[40];
double shadowsize;
int gotrect;


TDH_errprog( "pl proc bevelrect" );


/* initialize */
strcpy( color, "" );
bevelsize = 0.1;
strcpy( lowbevelcolor, "0.6" );
strcpy( hibevelcolor, "0.8" );
strcpy( shadowcolor, "" );
gotrect = 0;


/* get attributes.. */
first = 1;
while( 1 ) {
	line = getnextattr( first, attr, val, &lvp, &nt );
	if( line == NULL ) break;
	first = 0;
	lineval = &line[lvp];

	if( stricmp( attr, "rectangle" )==0 ) {
                getbox( "box", lineval, &xlo, &ylo, &xhi, &yhi );
		gotrect = 1;
		}
	else if( stricmp( attr, "color" )==0 ) strcpy( color, val );
	else if( stricmp( attr, "bevelsize" )==0 ) bevelsize = atof( val );
	else if( stricmp( attr, "shadowsize" )==0 ) shadowsize = atof( val );
	else if( stricmp( attr, "lowbevelcolor" )==0 ) strcpy( lowbevelcolor, val );
	else if( stricmp( attr, "hibevelcolor" )==0 ) strcpy( hibevelcolor, val );
	else if( stricmp( attr, "shadowcolor" )==0 ) strcpy( shadowcolor, val );

	else Eerr( 1, "attribute not recognized", attr );
	}



/* now do the plotting work.. */

if( !gotrect ) return( Eerr( 695, "No rectangle specified", "" ));

if( color[0] != '\0' ) Ecblock( xlo, ylo, xhi, yhi, color, 0 );

Ecblockdress( xlo, ylo, xhi, yhi,
        bevelsize, lowbevelcolor, hibevelcolor, shadowsize, shadowcolor);

return( 0 );
}
